<template>

    <div class="main-content">
      <breadcrumb separator="›">
        <breadcrumb-item label="Início" to="/"></breadcrumb-item>
      </breadcrumb>

      <nav class="nav">
        <div class="nav-left">
          <div class="nav-item">
            <h2 class="title">Relatórios</h2>
          </div>
        </div>
      </nav>


      <div class="the-content">
        <loader :show="showLoading" text="Aguarde..." backdropColor="#fff">
          <nav class="nav">
            <div class="nav-left">
                <div class="nav-item">
                  Selecione um relatório:
                </div>
                <div class="nav-item">
                  <span class="select">
                    <select v-model="report">
                      <option v-for="(report, index) in reportNamesList" :value="report" :key="index">{{report.label}}</option>
                    </select>
                  </span>
                </div>
                <div class="nav-item">
                  <button type="button" class="button is-info" :disabled="disableBtn" @click="generate">Gerar</button>
                </div>
            </div>
          </nav>
        </loader>

        <p class="download-link-container has-text-centered" v-if="showDownloadLink">
          <a class="button is-success is-large"
            :download="file.name"
            :href="file.url">
            <span class="icon is-medium">
              <i class="fa fa-download"></i>
            </span>
            <span>Baixar Relatório</span>
          </a>
        </p>

      </div>
   
    </div>

</template>

<script>

  import { getReport } from '../api/reports.service.js'
  import moment from 'moment'
  import loader from './loader-component.vue'

  export default {
    name: 'Reports',
    components: { loader },
    data () {
      return {
        report: {
          value: 'users',
          label: 'Usuários'
        },
        file: {
          url: "",
          name: ""
        },
        showLoading: false,
        showDownloadLink: false,
        disableBtn: false,
        reportNamesList: [
          {
            value: 'users',
            label: 'Usuários'
          }
        ],
        eventsList: []
      }
    },

    methods: {
      generate() {
        this.showLoading = true;
        getReport(this.report.value)
          .then(
            success => {
              this.file.name = `${this.report.label}-${moment(new Date()).format('DD.MM.YYYY')}.xlsx`;
              this.file.url = success
              this.showDownloadLink = true;
              this.showLoading = false;
            },
            error => {
              this.$notify.open({
                content: error.responseJSON.message,
                type: 'danger',
                title: "Erro"
              })
            }
          )
      }
    }

  }
</script>

<style>
  .download-link-container {
    margin-top: 50px;
  }
</style>
